package stockquote;

public class StockQuoteServiceProxy implements stockquote.StockQuoteService {
  private boolean _useJNDI = true;
  private String _endpoint = null;
  private stockquote.StockQuoteService __stockQuoteService = null;
  
  public StockQuoteServiceProxy() {
    _initStockQuoteServiceProxy();
  }
  
  private void _initStockQuoteServiceProxy() {
  
    if (_useJNDI) {
      try {
        javax.naming.InitialContext ctx = new javax.naming.InitialContext();
        __stockQuoteService = ((stockquote.StockQuoteServiceService)ctx.lookup("java:comp/env/service/StockQuoteServiceService")).getStockQuoteService();
      }
      catch (javax.naming.NamingException namingException) {}
      catch (javax.xml.rpc.ServiceException serviceException) {}
    }
    if (__stockQuoteService == null) {
      try {
        __stockQuoteService = (new stockquote.StockQuoteServiceServiceLocator()).getStockQuoteService();
        
      }
      catch (javax.xml.rpc.ServiceException serviceException) {}
    }
    if (__stockQuoteService != null) {
      if (_endpoint != null)
        ((javax.xml.rpc.Stub)__stockQuoteService)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
      else
        _endpoint = (String)((javax.xml.rpc.Stub)__stockQuoteService)._getProperty("javax.xml.rpc.service.endpoint.address");
    }
    
  }
  
  
  public void useJNDI(boolean useJNDI) {
    _useJNDI = useJNDI;
    __stockQuoteService = null;
    
  }
  
  public String getEndpoint() {
    return _endpoint;
  }
  
  public void setEndpoint(String endpoint) {
    _endpoint = endpoint;
    if (__stockQuoteService != null)
      ((javax.xml.rpc.Stub)__stockQuoteService)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    
  }
  
  public stockquote.StockQuoteService getStockQuoteService() {
    if (__stockQuoteService == null)
      _initStockQuoteServiceProxy();
    return __stockQuoteService;
  }
  
  public float getQuote(java.lang.String symbol) throws java.rmi.RemoteException{
    if (__stockQuoteService == null)
      _initStockQuoteServiceProxy();
    return __stockQuoteService.getQuote(symbol);
  }
  
  
}